﻿AnchorMinimap = CreateFrame("Frame","Move_Minimap",UIParent)
AnchorMinimap:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -21, 45)
CreateAnchor(AnchorMinimap, "Move minimap", 19, 19)

local module = {}
module.name = "cfgMinimap"
module.Init = function()
	if not tDB.modules[module.name] then return end
	local settings = tDB

AnchorMinimap:SetWidth(tDB["cfgMinimap"]["size"])
AnchorMinimap:SetHeight(tDB["cfgMinimap"]["size"])
	
----------------------------------------------------------------------------------------
-- aMinimap
-- ALZA - 2010
----------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------
-- Shape, location and scale
----------------------------------------------------------------------------------------

local mscale = tDB["cfgMinimap"]["size"]/(Minimap:GetWidth())

MinimapCluster:SetScale(mscale)

Minimap:ClearAllPoints()
Minimap:SetPoint("TOPLEFT", AnchorMinimap)
Minimap:SetMaskTexture(tDB["cfgMedia"]["textureBlank"])
Minimap:SetFrameStrata("LOW")

local bordrd = CreateFrame("Frame", nil, UIParent)
bordrd:SetPoint("TOPLEFT", Minimap, -1, 1)
bordrd:SetPoint("BOTTOMRIGHT", Minimap, 1, -1)
SetTemplate(bordrd, "button")

----------------------------------------------------------------------------------------
-- Mask texture
----------------------------------------------------------------------------------------
local hint = CreateFrame("Frame")
local total = 0
local SetTextureTrick = function(self, elapsed)
    total = total + elapsed
    if(total > 2) then
        Minimap:SetMaskTexture(tDB["cfgMedia"]["textureBlank"])
        hint:SetScript("OnUpdate", nil)
    end
end

hint:RegisterEvent("PLAYER_LOGIN")
hint:SetScript("OnEvent", function()
    hint:SetScript("OnUpdate", SetTextureTrick)
end)

----------------------------------------------------------------------------------------
-- Mousewheel zoom
----------------------------------------------------------------------------------------
Minimap:EnableMouseWheel(true)
Minimap:SetScript("OnMouseWheel", function(_, zoom)
    if zoom > 0 then
        Minimap_ZoomIn()
    else
        Minimap_ZoomOut()
    end
end)

----------------------------------------------------------------------------------------
-- Hide ugly icons
----------------------------------------------------------------------------------------
local dummy = function() end
local _G = getfenv(0)

local frames = {
    "GameTimeFrame",
    "MinimapBorderTop",
    "MinimapNorthTag",
    "MinimapBorder",
    "MinimapZoneTextButton",
    "MinimapZoomOut",
    "MinimapZoomIn",
    "MiniMapVoiceChatFrame",
    "MiniMapWorldMapButton",
    "MiniMapMailBorder",
    "MiniMapBattlefieldBorder",
}

for i in pairs(frames) do
    _G[frames[i]]:Hide()
    _G[frames[i]].Show = dummy
end
MinimapCluster:EnableMouse(false)

----------------------------------------------------------------------------------------
-- Tracking text and icon
----------------------------------------------------------------------------------------

MiniMapTrackingBackground:SetAlpha(0)
MiniMapTrackingButton:SetAlpha(0)
MiniMapTracking:ClearAllPoints()
MiniMapTracking:SetPoint("BOTTOMLEFT", Minimap, -5, -4)
MiniMapTrackingButtonBorder:SetTexture(nil)
MiniMapTrackingBackground:Hide()
MiniMapTrackingIconOverlay:SetTexture(nil)
MiniMapTracking:SetScale(1)

----------------------------------------------------------------------------------------
-- BG icon
----------------------------------------------------------------------------------------
MiniMapBattlefieldFrame:ClearAllPoints()
MiniMapBattlefieldFrame:SetPoint("TOP", Minimap, "TOP", 1, 5)

----------------------------------------------------------------------------------------
-- Feedback Beta Button
----------------------------------------------------------------------------------------
if FeedbackUIButton ~= nil then
FeedbackUIButton:ClearAllPoints()
FeedbackUIButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMRIGHT", 3, 5)
FeedbackUIButton:SetAlpha(0.5)
end

----------------------------------------------------------------------------------------
-- Random Group icon
----------------------------------------------------------------------------------------
MiniMapLFGFrame:ClearAllPoints()
MiniMapLFGFrameBorder:SetAlpha(0)
MiniMapLFGFrame:SetPoint("TOP", Minimap, "TOP", 1, 8)

--LFDSearchStatus:SetClampedToScreen(true)
--LFDSearchStatus:SetFrameStrata("TOOLTIP")

----------------------------------------------------------------------------------------
-- Instance Difficulty icon
----------------------------------------------------------------------------------------
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 3, 2)
MiniMapInstanceDifficulty:SetFrameStrata("TOOLTIP")

----------------------------------------------------------------------------------------
-- Guild Instance Difficulty icon
----------------------------------------------------------------------------------------
GuildInstanceDifficulty:ClearAllPoints()
GuildInstanceDifficulty:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, 2)
GuildInstanceDifficulty:SetFrameStrata("TOOLTIP")
GuildInstanceDifficulty:SetScale(0.85)

----------------------------------------------------------------------------------------
-- Mail icon
----------------------------------------------------------------------------------------
MiniMapMailFrame:ClearAllPoints()
MiniMapMailFrame:SetPoint("BOTTOMRIGHT", Minimap, "BOTTOMRIGHT", 6, -8)
MiniMapMailIcon:SetTexture("Interface\\AddOns\\TheThunderUI\\media\\mail")

HelpOpenTicketButton:SetParent(Minimap)
HelpOpenTicketButton:ClearAllPoints()
HelpOpenTicketButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", -6, 12)
----------------------------------------------------------------------------------------
-- Invites Icon
----------------------------------------------------------------------------------------
GameTimeCalendarInvitesTexture:ClearAllPoints()
GameTimeCalendarInvitesTexture:SetAlpha(0)
GameTimeCalendarInvitesTexture:Hide()
GameTimeCalendarInvitesTexture.Show = dummy --not tested
--GameTimeCalendarInvitesTexture:SetParent("Minimap")
--GameTimeCalendarInvitesTexture:SetPoint("TOPRIGHT")

----------------------------------------------------------------------------------------
-- Right click menu
----------------------------------------------------------------------------------------
local menuFrame = CreateFrame("Frame", "MinimapRightClickMenu", UIParent, "UIDropDownMenuTemplate")
local menuList = {
	{text = CHARACTER_BUTTON, notCheckable = 1,
		func = function() ToggleCharacter("PaperDollFrame") end},
	{text = SPELLBOOK_ABILITIES_BUTTON, notCheckable = 1,
		func = function() if not SpellBookFrame:IsShown() then ShowUIPanel(SpellBookFrame) else HideUIPanel(SpellBookFrame) end end},
	{text = TALENTS_BUTTON, notCheckable = 1,
		func = function()
			if not PlayerTalentFrame then
				LoadAddOn("Blizzard_TalentUI")
			end
			if not GlyphFrame then
				LoadAddOn("Blizzard_GlyphUI")
			end
			if UnitLevel("player") >= SHOW_TALENT_LEVEL then
				PlayerTalentFrame_Toggle()
			else
				print("|cffffff00"..format(FEATURE_BECOMES_AVAILABLE_AT_LEVEL, SHOW_TALENT_LEVEL).."|r")
			end
		end},
	{text = ACHIEVEMENT_BUTTON, notCheckable = 1,
		func = function() ToggleAchievementFrame() end},
	{text = QUESTLOG_BUTTON, notCheckable = 1,
		func = function() ToggleFrame(QuestLogFrame) end},
	{text = SOCIAL_BUTTON, notCheckable = 1,
		func = function() ToggleFriendsFrame(1) end},
	{text = PLAYER_V_PLAYER, notCheckable = 1,
		func = function()
			if UnitLevel("player") >= SHOW_PVP_LEVEL then
				ToggleFrame(PVPFrame)
			else
				print("|cffffff00"..format(FEATURE_BECOMES_AVAILABLE_AT_LEVEL, SHOW_PVP_LEVEL).."|r")
			end
		end},
	{text = ACHIEVEMENTS_GUILD_TAB, notCheckable = 1,
		func = function()
			if IsInGuild() then
				if not GuildFrame then
					LoadAddOn("Blizzard_GuildUI")
				end
				ToggleGuildFrame()
				GuildFrame_TabClicked(GuildFrameTab2)
			else
				if not LookingForGuildFrame then
					LoadAddOn("Blizzard_LookingForGuildUI")
				end
				if not LookingForGuildFrame then return end
				LookingForGuildFrame_Toggle()
			end
		end},
	{text = LFG_TITLE, notCheckable = 1,
		func = function()
			if UnitLevel("player") >= SHOW_LFD_LEVEL then
				ToggleFrame(LFDParentFrame)
			else
				print("|cffffff00"..format(FEATURE_BECOMES_AVAILABLE_AT_LEVEL, SHOW_LFD_LEVEL).."|r")
			end
		end},
	{text = RAID_FINDER, notCheckable = 1,
		func = function() ToggleFrame(RaidParentFrame) end}, --ToggleFrame(RaidParentFrame)
	{text = HELP_BUTTON, notCheckable = 1,
		func = function() ToggleHelpFrame() end},
	{text = "Calendar", notCheckable = 1,
		func = function() if not CalendarFrame then LoadAddOn("Blizzard_Calendar") end Calendar_Toggle() end},
	{text = ENCOUNTER_JOURNAL, notCheckable = 1,
		func = function() ToggleEncounterJournal() end},
}

----------------------------------------------------------------------------------------
-- Click function
----------------------------------------------------------------------------------------
Minimap:SetScript("OnMouseUp", function(_, button)
    if(button=="RightButton") then
        EasyMenu(menuList, menuFrame, "cursor", 0, 0, "MENU", 2)
	else
		Minimap_OnClick(_,click)
    end
end)

--------------------------------------------------------------------
-- Minimap Location mousover
--------------------------------------------------------------------

local ZZFramE = CreateFrame("Frame")

ZOMGTEXT = UIParent:CreateFontString(nil, "OVERLAY")
ZOMGTEXT:SetFont(tDB["cfgMedia"]["font"], tDB["cfgMedia"]["fontSize"], "OUTLINE")
ZOMGTEXT:SetPoint("TOP", Minimap, 0, -20)
ZOMGTEXT:SetWidth((Minimap:GetWidth() - 25))
ZOMGTEXT:SetAlpha(0)

	local int = 1
	local function Update(self, t)
		int = int - t
		if int < 0 then
			local x, y = GetPlayerMapPosition("player")
				if (x == 0 and y == 0) then
				ZOMGTEXT:SetText("|cff9DC7CC"..GetZoneText());
			else
				ZOMGTEXT:SetText("|cff9DC7CC"..GetZoneText().."\n"..string.format("%.1f | %.1f",x * 100,y * 100));
			end
			int = 1
		end
	end
		
Minimap:SetScript("OnEnter", function()
	UIFrameFadeIn(ZOMGTEXT, 0.15, ZOMGTEXT:GetAlpha(), 1)
	end)
Minimap:SetScript("OnLeave", function()
	UIFrameFadeIn(ZOMGTEXT, 0.15, ZOMGTEXT:GetAlpha(), 0)
	end)
	
ZZFramE:SetScript("OnUpdate", Update)
Update(ZZFramE, 10)

--------------------------------------------------------------------
-- Clock
--------------------------------------------------------------------

if not IsAddOnLoaded("Blizzard_TimeManager") then
	LoadAddOn("Blizzard_TimeManager")
end
TimeManagerClockButton:Hide()

end
tinsert(ThunderUI.modules, module)